#include <stdlib.h>
#include <math.h>
#include "my_gfx.h"

/* Funkcje min(), max() */
#define min(a,b) ( (a) < (b) ? (a) : (b) )
#define max(a,b) ( (a) > (b) ? (a) : (b) )

extern int SinTable[256];
extern int CosTable[256];

/* Deklaracje funkcji */
void Calc_Phongmap(bitmap *map)
{
  int   x, y;
  float nx, ny, nz;
  BYTE  *temp;

  /* Utworzenie phong mapy */
  temp = map->data;
  for (y = 0; y < 256; y++)
    for (x = 0; x < 256; x++, temp++) {
      nx = (x - 128) / 128.0;
      ny = (y - 128) / 128.0;
      nz = 1 - sqrt(nx * nx + ny * ny);
      if(nz < 0) nz=0;

      *temp = (BYTE) min( 255, ( nz * 191 + nz * nz * 128 ) );
   }
}

void Calc_SinCos_Table(void)
{
  int i;

  for(i=0; i < 256; i++) SinTable[i] = (sin(i*PI/128)*256);
  for(i=0; i < 256; i++) CosTable[i] = (cos(i*PI/128)*256);
}

void Do_bump(bitmap *texture, bitmap *envmap, int lx, int ly)
{
  int   x, y;
  int   nx, ny;
  BYTE  *temp, *temp2;

  /* Poprawienie wspolrzednych swiatla, zeby nie dodawac do normalnych */
  lx += 128;
  ly += 128;

  /* Glowna petla */
  temp  = virtual_screen;
  temp2 = texture->data;
  temp  += 320;
  temp2 += 320;
  for (y = 1; y < 199; y++, temp+=2, temp2+=2)
    for (x = 1; x < 319; x++,temp++, temp2++)
    {
      /* Obliczenie normalnej do punktu */
      nx = *(temp2+1)   - *(temp2-1);
      ny = *(temp2+320) - *(temp2-320);

      /* Obliczenie (u,v) dla envmapy w stosunku do polozenia swiatla */
      nx -= (x - lx);
      ny -= (y - ly);

      /* Sprawdzenie czy wspolrzedne sa w zakresie 0..256 */
      if( nx > 255 ) nx = 255;
      if( nx < 0   ) nx = 0;
      if( ny > 255 ) ny = 255;
      if( ny < 0   ) ny = 0;

      *temp = *( envmap->data + nx + (ny << 8) );
   }
}
