// Zmienne zewnetrzne z water.c
extern int  Height[2][64000];
extern BYTE w_katx, w_katy;

/* Typ przechowywujacy dane o jednym napisie */
typedef struct{
  int s_x, s_y;      // pozycja lewego gornego rogu w obrazku
  int s2_x, s2_y;    // pozycja prawego dolnego rogu w obrazku
  int d_x, d_y;      // pozycja na ekranie
}linia;

/* Typ przechowywujacy dane o jednym punkcie w morphingu */
typedef struct{
  int  posx, posy;
  int  dx, dy;
  BYTE color;
  BYTE active;
}punkt;

/* Typ przechowywujacy dane o jednej pozycji kamery na sciezce */
typedef struct {
  double  x, y, z;
  int     ax, ay, az;
  int    steps;
}campos;

/* Deklaracje funkcji */
/* ===================== Funkcje z modulu shuvax.c ======================== */
void MIDAS_CALL TimerCallback(void);
void MIDAS_CALL SyncCallback(unsigned syncNum, unsigned position, unsigned row);
void MIDASerror(void);
void fadein(RGB *pal, BYTE speed);
void fadeout(RGB *pal, BYTE speed);
void fade_from_white(RGB *pal, BYTE speed);
void copy_selection(bitmap *src, int b_x, int b_y, int width, int height,
                    int x, int y);
void update_envmap(bitmap *src, BYTE *dst, int b_x, int b_y,
                   int b2_x, int b2_y, int x, int y, BYTE col);
void shutdown(void);

void CalculateMorphTable(bitmap *src);
void Do_morph(void);
void Draw_morph(void);

/* ===================== Funkcje z modulu lens.c ========================== */
void Create_lens_table(void);
void Do_lens(bitmap *b, int x, int y);

/* ===================== Funkcje z modulu gel.c =========================== */
void Do_wave(BYTE *dst, int dx, int dy);
void Create_Sin_Table(void);

/* ==================== Funkcje z modulu credits.c ======================== */
void Calc_Lookup_Table(void);
void Scale_buffer(BYTE *buf1, BYTE *buf2);
void Blur_buffer (BYTE *buf1, BYTE *buf2);
void Do_garbage(BYTE *where);
void get_line(bitmap src, BYTE *dst, int x, int y, int width, int height);
void put_line(BYTE *src, BYTE *dst, int x, int y, int width, int height,
              BYTE color);

/* ==================== Funkcje z modulu bump.c =========================== */
void Do_bump(bitmap *b, bitmap *envmap, int lx, int ly);
void Calc_SinCos_Table(void);
void Calc_Phongmap(bitmap *map);

/* ==================== Funkcje z modulu zoom.c =========================== */
void Do_rotozoom(bitmap *b, BYTE *dst, int scale, BYTE angle);
void Do_signzoom(bitmap *b, int scale);

/* ==================== Funkcje z modulu tunnel.c ========================= */
void Do_tunnel(bitmap *b, BYTE *dst, WORD increment);
void Create_tunnel_table(BYTE persp, DWORD *tun_tabl);

/* ==================== Funkcje z modulu water.c ========================== */
void Do_water(bitmap *b);
void Do_surfer();
void Do_Sign(bitmap *src, int posx, int posy);
